Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src Add new ATF C++ tests in usr.bin/c++: t_static_destructor



details:   https://anonhg.NetBSD.org/src/rev/f4d97d524989
branches:  trunk
changeset: 823896:f4d97d524989
user:      kamil <kamil%NetBSD.org@localhost>
date:      Sun May 14 02:02:25 2017 +0000

description:
Add new ATF C++ tests in usr.bin/c++: t_static_destructor

These tests are cloned from t_cxxruntime and check proper order of destructor
calls. They must be reported in reverse order of constructor completion.

Added tests:
 - static_destructor
 - static_destructor_pic
 - static_destructor_pie
 - static_destructor32

This test file replaces src/regress/usr.bin/c++/static_destructor.

diffstat:

 distrib/sets/lists/tests/mi              |    3 +-
 tests/usr.bin/c++/Makefile               |    3 +-
 tests/usr.bin/c++/t_static_destructor.sh |  194 +++++++++++++++++++++++++++++++
 3 files changed, 198 insertions(+), 2 deletions(-)

diffs (231 lines):

diff -r 12b2e774fee7 -r f4d97d524989 distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi       Sun May 14 01:13:44 2017 +0000
+++ b/distrib/sets/lists/tests/mi       Sun May 14 02:02:25 2017 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.740 2017/05/14 01:03:21 kamil Exp $
+# $NetBSD: mi,v 1.741 2017/05/14 02:02:25 kamil Exp $
 #
 # Note: don't delete entries from here - mark them as "obsolete" instead.
 #
@@ -3589,6 +3589,7 @@
 ./usr/tests/usr.bin/c++/Kyuafile               tests-usr.bin-tests     compattestfile,atf,kyua,cxx
 ./usr/tests/usr.bin/c++/t_cxxruntime           tests-usr.bin-tests     compattestfile,atf,cxx
 ./usr/tests/usr.bin/c++/t_hello                        tests-usr.bin-tests     compattestfile,atf,cxx
+./usr/tests/usr.bin/c++/t_static_destructor    tests-usr.bin-tests     compattestfile,atf,cxx
 ./usr/tests/usr.bin/cc                         tests-usr.bin-tests     compattestfile,atf
 ./usr/tests/usr.bin/cc/Atffile                 tests-usr.bin-tests     compattestfile,atf
 ./usr/tests/usr.bin/cc/Kyuafile                        tests-usr.bin-tests     compattestfile,atf,kyua
diff -r 12b2e774fee7 -r f4d97d524989 tests/usr.bin/c++/Makefile
--- a/tests/usr.bin/c++/Makefile        Sun May 14 01:13:44 2017 +0000
+++ b/tests/usr.bin/c++/Makefile        Sun May 14 02:02:25 2017 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: Makefile,v 1.2 2017/05/14 01:03:21 kamil Exp $
+# $NetBSD: Makefile,v 1.3 2017/05/14 02:02:25 kamil Exp $
 
 .include <bsd.own.mk>
 
@@ -6,5 +6,6 @@
 
 TESTS_SH=      t_cxxruntime
 TESTS_SH+=     t_hello
+TESTS_SH+=     t_static_destructor
 
 .include <bsd.test.mk>
diff -r 12b2e774fee7 -r f4d97d524989 tests/usr.bin/c++/t_static_destructor.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/usr.bin/c++/t_static_destructor.sh  Sun May 14 02:02:25 2017 +0000
@@ -0,0 +1,194 @@
+#      $NetBSD: t_static_destructor.sh,v 1.1 2017/05/14 02:02:25 kamil Exp $
+#
+# Copyright (c) 2017 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Kamil Rytarowski.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+atf_test_case static_destructor
+static_destructor_head() {
+       atf_set "descr" "compile and run \"hello world\""
+       atf_set "require.progs" "c++"
+}
+
+atf_test_case static_destructor_pic
+static_destructor_pic_head() {
+       atf_set "descr" "compile and run PIC \"hello world\""
+       atf_set "require.progs" "c++"
+}
+
+atf_test_case static_destructor_pie
+static_destructor_pie_head() {
+       atf_set "descr" "compile and run position independent (PIE) \"hello world\""
+       atf_set "require.progs" "c++"
+}
+
+atf_test_case static_destructor32
+static_destructor32_head() {
+       atf_set "descr" "compile and run \"hello world\" for/in netbsd32 emulation"
+       atf_set "require.progs" "c++ file diff cat"
+}
+
+static_destructor_body() {
+       cat > test.cpp << EOF
+#include <iostream>
+struct A {
+       int i;
+       A(int i):i(i){std::cout << "CTOR A" << std::endl;}
+       ~A() {std::cout << "DTOR A:" << i << std::endl;}
+};
+struct B {
+       A *m_a;
+       B(){static A s_a(10);m_a=&s_a;std::cout << "CTOR B" << std::endl;}
+       ~B(){std::cout << "DTOR B:" << (*m_a).i << std::endl;(*m_a).i = 20;}
+};
+int main(void) {struct B b;return 0;}
+EOF
+       atf_check -s exit:0 -o ignore -e ignore c++ -o hello test.cpp
+       atf_check -s exit:0 -o inline:"CTOR A\nCTOR B\nDTOR B:10\nDTOR A:20\n" ./hello
+}
+
+static_destructor_pic_body() {
+       cat > test.cpp << EOF
+#include <cstdlib>
+int callpic(void);
+int main(void) {callpic();exit(0);}
+EOF
+       cat > pic.cpp << EOF
+#include <iostream>
+struct A {
+       int i;
+       A(int i):i(i){std::cout << "CTOR A" << std::endl;}
+       ~A() {std::cout << "DTOR A:" << i << std::endl;}
+};
+struct B {
+       A *m_a;
+       B(){static A s_a(10);m_a=&s_a;std::cout << "CTOR B" << std::endl;}
+       ~B(){std::cout << "DTOR B:" << (*m_a).i << std::endl;(*m_a).i = 20;}
+};
+int callpic(void) {struct B b;}
+EOF
+
+       atf_check -s exit:0 -o ignore -e ignore \
+           c++ -fPIC -shared -o libtest.so pic.cpp
+       atf_check -s exit:0 -o ignore -e ignore \
+           c++ -o hello test.cpp -L. -ltest
+
+       export LD_LIBRARY_PATH=.
+       atf_check -s exit:0 -o inline:"CTOR A\nCTOR B\nDTOR B:10\nDTOR A:20\n" ./hello
+}
+
+static_destructor_pie_body() {
+       # check whether this arch supports -pie
+       if ! c++ -pie -dM -E - < /dev/null 2>/dev/null >/dev/null; then
+               atf_skip "c++ -pie not supported on this architecture"
+       fi
+       cat > test.cpp << EOF
+#include <iostream>
+struct A {
+       int i;
+       A(int i):i(i){std::cout << "CTOR A" << std::endl;}
+       ~A() {std::cout << "DTOR A:" << i << std::endl;}
+};
+struct B {
+       A *m_a;
+       B(){static A s_a(10);m_a=&s_a;std::cout << "CTOR B" << std::endl;}
+       ~B(){std::cout << "DTOR B:" << (*m_a).i << std::endl;(*m_a).i = 20;}
+};
+int main(void) {struct B b;return 0;}
+EOF
+       atf_check -s exit:0 -o ignore -e ignore c++ -fpie -pie -o hello test.cpp
+       atf_check -s exit:0 -o inline:"CTOR A\nCTOR B\nDTOR B:10\nDTOR A:20\n" ./hello
+}
+
+static_destructor32_body() {
+       # check whether this arch is 64bit
+       if ! c++ -dM -E - < /dev/null | fgrep -q _LP64; then
+               atf_skip "this is not a 64 bit architecture"
+       fi
+       if ! c++ -m32 -dM -E - < /dev/null 2>/dev/null > ./def32; then
+               atf_skip "c++ -m32 not supported on this architecture"
+       else
+               if fgrep -q _LP64 ./def32; then
+                       atf_fail "c++ -m32 does not generate netbsd32 binaries"
+               fi
+       fi
+
+       cat > test.cpp << EOF
+#include <iostream>
+struct A {
+       int i;
+       A(int i):i(i){std::cout << "CTOR A" << std::endl;}
+       ~A() {std::cout << "DTOR A:" << i << std::endl;}
+};
+struct B {
+       A *m_a;
+       B(){static A s_a(10);m_a=&s_a;std::cout << "CTOR B" << std::endl;}
+       ~B(){std::cout << "DTOR B:" << (*m_a).i << std::endl;(*m_a).i = 20;}
+};
+int main(void) {struct B b;return 0;}
+EOF
+       atf_check -s exit:0 -o ignore -e ignore c++ -o hello32 -m32 test.cpp
+       atf_check -s exit:0 -o ignore -e ignore c++ -o hello64 test.cpp
+       file -b ./hello32 > ./ftype32
+       file -b ./hello64 > ./ftype64
+       if diff ./ftype32 ./ftype64 >/dev/null; then
+               atf_fail "generated binaries do not differ"
+       fi
+       echo "32bit binaries on this platform are:"
+       cat ./ftype32
+       echo "While native (64bit) binaries are:"
+       cat ./ftype64
+       atf_check -s exit:0 -o inline:"CTOR A\nCTOR B\nDTOR B:10\nDTOR A:20\n" ./hello32
+
+       # do another test with static 32bit binaries
+       cat > test.cpp << EOF
+#include <iostream>
+struct A {
+       int i;
+       A(int i):i(i){std::cout << "CTOR A" << std::endl;}
+       ~A() {std::cout << "DTOR A:" << i << std::endl;}
+};
+struct B {
+       A *m_a;
+       B(){static A s_a(10);m_a=&s_a;std::cout << "CTOR B" << std::endl;}
+       ~B(){std::cout << "DTOR B:" << (*m_a).i << std::endl;(*m_a).i = 20;}
+};
+int main(void) {struct B b;return 0;}
+EOF
+       atf_check -s exit:0 -o ignore -e ignore c++ -o hello -m32 \
+           -static test.cpp
+       atf_check -s exit:0 -o inline:"CTOR A\nCTOR B\nDTOR B:10\nDTOR A:20\n" ./hello
+}
+
+atf_init_test_cases()
+{
+
+       atf_add_test_case static_destructor
+       atf_add_test_case static_destructor_pic
+       atf_add_test_case static_destructor_pie
+       atf_add_test_case static_destructor32
+}



Home | Main Index | Thread Index | Old Index